#include <iostream>

using namespace std;

int main()
{
    int n;
    cin >> n;
    int a[n];
    int b[n];
    int broac = 0;
    int brojac = 0;
    
    for(int i = 1; i <= n; i++){
        cin >> a[i];
    }
    for(int i = 1; i <= n; i++){
        int l, r;
        l = a[i];
        r = a[n];
        for(int j = l; j <= r; j++){
            int c = a[j] ^ a[j + 1];
            if(c > broac)
                broac = c;
        }
    }
    for(int i = 1; i <= n; i++){
        cin >> b[i];
    }
    for(int i = 1; i <= n; i++){
        int l, r;
        l = a[i];
        r = a[n];
        for(int j = l; j <= r; j++){
            int c = b[j] && b[j + 1];
                if(c > brojac)
                    brojac = c;
        }
    }
    int proizvod = broac * brojac;
    cout << proizvod << endl;
}